Subject: Port to R3000 Indigo

From: Jeremy Parsons <[email-masked]>
Date: Fri, 26 Mar 1999 15:35:47 -0500

I think it would be very relevant.  My company recently sold around 30
of the R3000 Indigo's.  Just about every person who bought one of these
was interested in the SGI/Linux project and wanted to know if they would
some day be able to run Linux on it.

Jeremy Parsons

---

From: tom <[email-masked]>
Date: Fri, 26 Mar 1999 16:46:20 -0500

And I know a group at KSC that's getting rid of a bunch of O2s.  We'd love to
grab them and make a nice little Beowulf cluster out of them :-). 
Unfortunately, we don't have the time at work to do a port :-(

--
   ______
  /     /|   ,--------------------------------------------,     //    //
 /_____/ |...| "Lower your shields and Open your Source." |   \X/   \X/
 |     | |   `--------------------------------------------'   600  2000
 |     | |          email:  [email-masked]                P166+ Powered by
 |_____|/           URL  :  http://erau.db.erau.edu/~flynnt     Linux

---

From: [email-masked] (Ariel Faigon)
Date: Fri, 26 Mar 1999 14:08:06 -0800 (PST)

As Linus use to say: talk is cheap, show me the code... ;-)

It won't happen by itself, only if someone devotes serious
time to it.  My personal feeling is that Linux on R3000
will not happen (there are cheaper and faster old pentium 90's
out there) but if someone builds it... I've been wrong before.

:
:And I know a group at KSC that's getting rid of a bunch of O2s.  We'd love to
:grab them and make a nice little Beowulf cluster out of them :-). 
:Unfortunately, we don't have the time at work to do a port :-(
:
:> I think it would be very relevant.  My company recently sold around 30
:> of the R3000 Indigo's.  Just about every person who bought one of these
:> was interested in the SGI/Linux project and wanted to know if they would
:> some day be able to run Linux on it.
:> 

-- 
Peace, Ariel

---

From: Martin Mielke <[email-masked]>
Date: Fri, 26 Mar 1999 22:21:01 +0000

> :> some day be able to run Linux on it.

Hello,

I'm new to this list, so please accept my apologies if this has been already
addressed.

Why porting it to the R3000? are there any big advantages in doing it? IMHO, it
would be clever and nicer to port Linux to, at least, R5K and above.
Are there any news on this issue?? what's the latest status?

Thanks in advance!

Best regards and have a good weekend,

Martin

--
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Martin Mielke - SysAdmin        Tel.: ++ 34 928 262299  c/. Albareda 54 - Atico
Jaleo Development Team          Fax : ++ 34 928 263504  E-35008 Las Palmas de GC
[email-masked]        http://www.jaleo.com/   Canary Islands / Spain

    "killing nature killing animals - don't disturb we love our chemicals"
                                        K.N.K.A. by Project Pitchfork
=-=-=-=-=-=-=-=-=-=-=-=-[ echo "\$0&\$0">_;chmod +x _;./_ ]-=-=-=-=-=-=-=-=-=-=-

---

From: Jurgen Kramer <[email-masked]>
Date: Fri, 26 Mar 1999 23:21:59 +0100

I am still hoping one day my R3000 Indigo will run Linux. The guys who
ported Linux to the DECstation with a R3000 showed it it possible to run
Linux on a MIPS R3000. We probably need some docs with specifics of the
Indigo to make it work (still not available?).

Jurgen Kramer

---

From: root <[email-masked]>
Date: Fri, 26 Mar 1999 23:15:09 +0000

> As Linus use to say: talk is cheap, show me the code... ;-)

As always!

> out there) but if someone builds it... I've been wrong before.

Are you saying that the effort necessary to port Linux to R3000 Indigo would be
better placed elsewhere?

> :> some day be able to run Linux on it.

The final portion of my original question, is really the most important - are the
hardware specifications/documentation available or are they considered
proprietary?

This issue alone is paramount since it substantially affects the "effort"
necessary to port.

Thanks

- Alan Hoyt -

---

From: "William J. Earl" <[email-masked]>
Date: Fri, 26 Mar 1999 15:52:55 -0800

Theodoros Nikitopoulos writes:
 > tom wrote:
 > > ? I think it would be very relevant.  My company recently sold around 30
 > > ? of the R3000 Indigo's.  Just about every person who bought one of these
 > > ? was interested in the SGI/Linux project and wanted to know if they would
 > > ? some day be able to run Linux on it.
 > > ?
 > > ? Jeremy Parsons
 > > --
 > 
 > 
 > I have a feeling that someone hasn't any chance to port Linux in the O2 or
 > Indigo2 platform unless Sillicon Graphics wants too. In other words, by
 > giving a great deal of information in public for building the appropriate
 > drivers. Am I wrong about it ?

      So far, we (SGI) have only released Indy information.  There is agreement
in principle to release information about more systems, but it is getting hard
to find Indigo R3000 documentation, except as IRIX source, and releasing that
has additional complications, although not necessarily insurmountable ones.

---

From: [email-masked] (Ariel Faigon)
Date: Fri, 26 Mar 1999 16:39:34 -0800 (PST)

Alan Hoyt said:
:>
:> It won't happen by itself, only if someone devotes serious
:> time to it.  My personal feeling is that Linux on R3000
:> will not happen (there are cheaper and faster old pentium 90's
:> out there) but if someone builds it... I've been wrong before.
:
:Are you saying that the effort necessary to port Linux to R3000
:Indigo would be better placed elsewhere?
:
[Obligatory Disclaimer:
 Everything I write below is personal views, no one appointed me
 to be an official SGI spokeperson]

In a way yes ;-)

For example, I personally would be much happier if the few people
who have the ability to make such port a reality would devote their
time on more attractive, newer machines.

The real scarcity is in talent who can make things happen.  There's
no scarcity in people who just "want" things to happen and voice
their wishes on various mailing lists.

If we could get talent to get involved with the SGI Intel machines
it would be IMHO more valuable; the reasons are simple:

	- We can leverage the thousands of precompiled PRMs out there
	  rather than duplicating work

	- The installed base of these systems is expected to be much
	  larger so the scarcity of talent with access to hardware
	  would likely be less grave.

	- The performance and attractiveness of these machines is
	  much higher.

	- Market realities: SGI as a company may be much more inclined
	  to put resources on something that is not a dead product.
	  and we have to realize that every response even on this
	  friendly mailing list, is in the end paid for by SGI since
	  people work on company time.

There's some work going on (while no one was taking notice, the 2.2.4
kernel just got a /dev/fb implementation from Jeff Newquist) so
we can have X11 (albeit unaccelerated) running on the SGI VisWS!
People are welcome to look at the code and get involved, it is all
completely open on www.linux.sgi.com (in the Intel section).

Regarding MIPS, for similar reasons, having the Indy port 'finished'
(it is not yet really easy to get up and running) or having support
for O2s, seems (at least to me) to be much more attractive than
R3000 Indigos.

Again, It is not that I don't want it to happen.  I'm just
asking myself, what would I (and many others) prefer to put
available talent energies on.   If we don't set priorities,
we run the risk of getting lost in multiple unfinished ports
and dilute our efforts and end results.

:
:The final portion of my original question, is really the most
:important - are the hardware specifications/documentation available
:or are they considered proprietary?
:
:This issue alone is paramount since it substantially affects the "effort"
:necessary to port.
:
I believe Bill Earl tried to locate some very old specs but
couldn't find them (and he can correct me if I'm wrong).  Indy
specs were sent (sorry I only have paper versions) to those
who have shown they are really serious and can make a difference
and asked for them.  The best source for older SGI machines
data is at:

	http://www.geocities.com/SiliconValley/Pines/2258/4dfaq.html

This is the best I could find on anything before my times at SGI...

-- 
Peace, Ariel

---

From: Theodoros Nikitopoulos <[email-masked]>
Date: Sat, 27 Mar 1999 03:45:38 +0200

By the way, SGI has officialy report to support Linux on visual
workstations. Any ideas if they will also transfer the desktop enviroment
commonly used in IRIX ? This seems to me very likely, in regards of
providing a common user interface both in IRIX based systems and Linux
based systems provided by SGI. That could be a great benefeat of the Linux
community..

Personally I haven't find any Linux user interface more nicely crafted
than SGI's 4DWM.

Theodore .

---

From: Steve Martin <[email-masked]>
Date: Fri, 26 Mar 1999 19:46:35 -0800

> drivers. Am I wrong about it ?

Well, regading the O2, several things come into factor if they were to release
info:
    1) They still support IRIX on the O2, and are still making money off of that.
 People that might get a new IRIX release or dev tools in the future
    might start using linux which would cost them money, and right now SGI can't
afford to lose any money at all.
    2) The O2 is still relatively new technology.  The software algorithms behind
the display mechanisms and such to support UMA and the various
    specialized components of the O2 are points of innovative technology,
releasing source(or even detailed information about the processes used)
    to the public might not be a wise thing to do.
    3)  Linux could surpass IRIX on the O2 easily, because the IRIX implementation
on the O2 is *crap*(relative to what I've seen on previous
    machines such as the Indy, Indigo2, Crimson, Indigo, etc..).  It has more bugs
regarding the graphics than I've seen since Windows 95 was
    first released.  I ended up spending half my time trying to avoid getting
kernel panics(note that in 6.3 things were bad, but in 6.5 things were
    better, although I had some problems with it and certain OpenGL applications.
(I had posted about the bug with a picture and such in
    comp.sys.sgi.bugs a while back as well.  An image of the screen is at
http://www.cubicsky.com/~tau/_o2bug.jpeg).  That was with running
    mere apps from the glut demo collection.  I also noticed some considerable
problems with 1600x1200@60hz(I wrote a vfo for that) although
    that is unsupported by SGI, and I can see why.

Overall, I think Linux on the O2 would be a great thing, yet I wonder if it would
be a wise business decision for SGI to support that at this time.
I suppose that the O2 is a previous generation machine, but then I look at the
VisualPC and see no real "workstation-calibur" software(regarding Windows NT), so
perhaps the O2 is the newest low-end "true workstation" by SGI, and thus SGI may
not want to release info on that.

We could always run the IRIX kernel and all the graphics stuff through a
dissassembler... :)

----Linux unrelated--
One unrelated sidenote that is a bug I've noticed both on the O2 and
Indigo2(Elan).   This is something you should try, run an app that uses
glPixelZoom(such as "resolution" which is one of the things included with
glut-3.7(I think)).  Move the window to off the screen(but still showing some of
the window area).  Increase the zoom, and notice that the window goes blank(or
displays multiple copies of the viewport within) on the Indigo2, or fills up the
window with lots of trash on the O2.  Is this a well known bug?  (basically a
problem with clipped glPixelZoom operations)
------------------

> Personally I haven't find any Linux user interface more nicely crafted

Well, you could always try a gtk theme with gnome, and a 4Dwm enlightenment
theme.  I've wanted to see that, make all my PCs look like the Indigo Magic
environment(hehe).  I agree 4Dwm&Indigo Magic are pretty much the best there is,
very innovative(introduced many things
unseen as well thought out as they were in this before).  Too bad I haven't seen
much in that respect lately from SGI... (whatever happened to doing innovative
things that changed computing like they used to?).  I had given a guy on
irc(efnet) some snapshots of some 4Dwm things as well as some desktop shots,
because he was interested in doing an enlightenment theme to make his PCs look
like 4Dwm, perhaps that'll happen.

> Theodore .

..
Steve Martin

---

From: Honza Pazdziora <[email-masked]>
Date: Mon, 29 Mar 1999 17:09:51 +0200

Would anybody know what is the proper PROMBLOCK value for
Origin200/R1000 systems and wherther it's still the same
linux_promblock structure as with Indys? Is sucha kind of information
available?

------------------------------------------------------------------------
 Honza Pazdziora | [email-masked] | http://www.fi.muni.cz/~adelton/
 make vmlinux.exe			-- SGI Visual Workstation Howto
Any spam sent to my email will be rewarded by complaint to your ISP abuse
  team and abuse teams of servers that relayed that message. It works.

---

From: Alan Hoyt <[email-masked]>
Date: Mon, 29 Mar 1999 23:38:10 +0000

Ariel Faigon wrote:

> ... <section omitted for brevity> ...
>

Two questions:

Does this mean that you are going to be posting the hardware specifications
for the Indigo 2, O2, etc.. (i.e. SGI's more recent systems) on your web
server for public access, or will this information be disseminated through
controlled channels?

Also,  if you are going to post the specs - when will they be available?

Just curious, since HP publicly released some detailed hardware specs for
their systems in PDF format to assist their Linux porting project - it's very
nice.

Thanks

 - Alan Hoyt -

---

From: [email-masked] (Ariel Faigon)
Date: Tue, 30 Mar 1999 00:53:03 -0800 (PST)

:Two questions:
:
:Does this mean that you are going to be posting the hardware specifications
:for the Indigo 2, O2, etc.. (i.e. SGI's more recent systems) on your web
:server for public access, or will this information be disseminated through
:controlled channels?
:
:Also,  if you are going to post the specs - when will they be available?
:
:Just curious, since HP publicly released some detailed hardware specs for
:their systems in PDF format to assist their Linux porting project - it's very
:nice.
:
:Thanks
:
: - Alan Hoyt -
:
Alan,

I believe this was referred to by Bill Earl in an earlier post.
Clearly, this needs further explanation.

Since the interfaces with SGI proprietary hardware were never meant
to be public, the only documentation you can really rely on to be
accurate and reliable is the (working) IRIX source code.  We would really
like to avoid publishing material that's incomplete, outdated, and
turns out to be more confusing than it is worth.

Now, if it were entirely in my hands, I would have gladly published
some source code.  The problem is much more complex than that.  The
IRIX source code includes licensed code from many external commercial
sources, AT&T SVR4, Sun, Xerox, etc. each surrounded by its own complex
licensing terms, so the lawyers need to look into this lest SGI
becomes liable by just making some "innocent goodwill" happen.  

I know it sounds lame, and I as much as anyone, hate this, but
this is reality, and it isn't simple as it may appear to some.
It requires a lot of legal (inspection and clearance) + engineering
(sanitize and clean up code) time which I'm not sure we can afford
on a global scale. 

The good news is that SGI is clearly putting much more emphasis
these days on developing hardware that is much more standard
and opening more and more source code (after legal has looked into
it and approved it).  Everything we have been doing in the past
year on the Linux front makes this clear that this is where we're
going.  I would like to request a bit of patience and support...
You are preaching to the choir here.

-- 
Peace, Ariel

---

From: Alan Hoyt <[email-masked]>
Date: Tue, 30 Mar 1999 15:29:04 +0000

> You are preaching to the choir here.

One last question:

I have an old Indigo and Indigo 2 - I am very interested and very serious about
porting Linux to one of these systems.  However, without detailed hardware specs.
a very difficult job becomes much much harder.  Can you throw a dog a bone?  Are
there any hardware specs. (NOT source code) that you are willing and/or capable
of providing at this time to get the ball rolling- without further delays
perpetrated by your legal department?

Thanks

 - Alan Hoyt -

---

From: Mike Shaver <[email-masked]>
Date: Wed, 31 Mar 1999 11:18:09 -0500

> (sanitize and clean up code) time which I'm not sure we can afford

Just to leap unnecessarily to Ariel's defense, I'll tell you that once
_all_ of Netscape, from Jim Barksdale on down, had decided to release
the source to Communicator, it tooks 3 months of about 70 engineers to
clean it up fully.  That meant removing code that had crypto elements
and code that was licensed from other companies.

Communicator is a 4-year-old product.  There are (well, were) still
people around who were a part of just about every deal that put code in
there, and could tell you where all but about 15 lines came from.

Now, we have people at Netscape (excuse me, AOL) who left SGI 8 years
ago, and still have code in the IRIX kernel[*].  The effort required to
sanitize the IRIX kernel and X server and the like would surely eclipse
our experiences.  No Small Task.

It is quite pointless, IMHO, to rail at Ariel about this; he and his
band of merry men have been fighting the good fight within SGI for
years, long before it was cool for a Unix company to do Linux.  If you
really want to help, I think the best thing to do is flank SGI: make
sure that the sales and marketing folk know that SGI's support for Linux
on their older hardware is significant to you as a once-and-future
customer.  (Where they should certainly be led to interpret
``significant'' as ``affecting future purchasing decisions''.)  If you
have friends on the board of SGI, maybe give them a call too. =)

[*] grep XXXbe /usr/include/sys/*.h; that's [email-masked].

Mike

-- 
588472.19 72598.35